"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseUncrumb = exports.toUncrumb = exports.Uncrumb = exports.PARTIAL_PREFIX = void 0;
const Base64_1 = require("../models/Base64");
exports.PARTIAL_PREFIX = '%';
class Uncrumb {
    constructor(deciphered, index) {
        this.deciphered = deciphered;
        this.index = index;
    }
    toSlice() {
        const s = this.deciphered.decoded().toString();
        return s;
    }
    toString() {
        return exports.PARTIAL_PREFIX + this.index.toString(16).padStart(2, '0') + this.deciphered.toString();
    }
}
exports.Uncrumb = Uncrumb;
const toUncrumb = (unparsed) => {
    const [index, deciphered] = (0, exports.parseUncrumb)(unparsed);
    const u = new Uncrumb(new Base64_1.Base64(deciphered), index);
    return u;
};
exports.toUncrumb = toUncrumb;
const parseUncrumb = (unparsed) => {
    if (unparsed.startsWith(exports.PARTIAL_PREFIX)) {
        unparsed = unparsed.substr(1);
    }
    const idxHex = unparsed.substr(0, 2);
    const idx = parseInt(idxHex, 16);
    const dec = unparsed.substr(2);
    if (!(0, Base64_1.isBase64String)(dec)) {
        throw new Error('not a base64-encoded string: ' + dec);
    }
    return [idx, dec];
};
exports.parseUncrumb = parseUncrumb;
