"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decrypt = void 0;
const Base64_1 = require("../models/Base64");
const crypto_1 = require("../crypto");
const ecies = __importStar(require("../crypto/ecies"));
const Uncrumb_1 = require("./Uncrumb");
const decrypt = (c, s) => __awaiter(void 0, void 0, void 0, function* () {
    let decrypted = '';
    if (s.privateKey !== null && s.privateKey !== undefined) {
        switch (s.encryptionAlgorithm) {
            case crypto_1.ECIES_ALGORITHM: {
                // IMPORTANT: the signer's private key hexadecimal string has to be passed through the `ecies.getPrivateKeyBuffer()` function beforehand
                const deciphered = yield ecies.decrypt(c.encrypted.toBytes(), s.privateKey);
                decrypted = deciphered.toString('base64');
                break;
            }
            default:
                throw new Error('unknown encryption algorithm: ' + s.encryptionAlgorithm);
        }
    }
    return new Uncrumb_1.Uncrumb(new Base64_1.Base64(decrypted), c.index);
});
exports.decrypt = decrypt;
__exportStar(require("./Collector"), exports);
__exportStar(require("./Uncrumb"), exports);
