import { Signer } from '../models/Signer';
export declare class Dispatcher {
    numberOfSlices: number;
    trustees: Array<Signer>;
    constructor(numberOfSlices: number, trustees: Array<Signer>);
    /**
       * Allocate returns a map of slice index -> trustees to sign, or an error if any.
       * It tries to uniformly distribute slices to trustees so that no trustee sign all slices and all slices are at least signed twice if possible.
       * Nota: the first slice (index 0) is reserved for data owners, so it should not be allocated.
       *
       * @returns a map of arrays of signers by slice index
       */
    allocate(): Map<number, Array<Signer>>;
}
//# sourceMappingURL=Dispatcher.d.ts.map