"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.encrypt = void 0;
const Base64_1 = require("../models/Base64");
const Crumb_1 = require("./Crumb");
const crypto_1 = require("../crypto");
const ecies = __importStar(require("../crypto/ecies"));
const encrypt = (data, index, s) => __awaiter(void 0, void 0, void 0, function* () {
    let crypted = '';
    if (s.publicKey !== null && s.publicKey !== undefined) {
        switch (s.encryptionAlgorithm) {
            case crypto_1.ECIES_ALGORITHM: {
                // IMPORTANT: the signer's public key hexadecimal string has to be passed through the `ecies.getPublicKeyBuffer()` function beforehand
                const ciphered = yield ecies.encrypt(Buffer.from(data), s.publicKey);
                crypted = ciphered.toString('base64');
                break;
            }
            default:
                throw new Error('unknown encryption algorithm: ' + s.encryptionAlgorithm);
        }
    }
    else {
        throw new Error('invalid empty public key');
    }
    const b64 = new Base64_1.Base64(crypted);
    return new Crumb_1.Crumb(b64, index, b64.length());
});
exports.encrypt = encrypt;
__exportStar(require("./Crumb"), exports);
__exportStar(require("./Dispatcher"), exports);
