import { Crumb } from '../Encrypter/Crumb';
export declare const NUMBER_OF_CHARACTERS = 32;
/**
 * Hasher generate a modified hash unique to a source and its signers, or recover the hash of the original data.
 * When applying it, it should prepend the crumbs to finalize the Crumbl.
 * Algorithm: N-32 last chars of the hex string of the hashed source + (32 last chars ^ padded/cut lexicographically sorted owners encrypted crumbs).toHex
 */
export declare class Hasher {
    readonly crumbs: ReadonlyArray<Crumb>;
    constructor(crumbs: ReadonlyArray<Crumb>);
    /**
     * Build the hashered prefix for the Crumbl
     *
     * @param {string} source - the data source
     * @returns the hashered string
     */
    apply(source: string): Promise<string>;
    /**
     * Recover the original hash
     *
     * @param {string} hashered - the hashered string
     * @returns the original hexadecimal representation of the hash of the source data
     */
    unapply(hashered: string): string;
}
//# sourceMappingURL=index.d.ts.map