import { CrumblMode } from '..';
import { Signer } from '../../models/Signer';
export interface Params {
    mode: CrumblMode;
    data: Array<string>;
    verificationHash?: string;
    htmlElement?: HTMLElement;
}
export declare class BrowserWorker {
    mode: CrumblMode;
    data: Array<string>;
    verificationHash?: string;
    htmlElement?: HTMLElement;
    constructor(p: Params);
    /**
       * Create a new crumbl using the passed credentials
       *
       * @param owners    A list of data owners
       * @param trustees  A list of third-party signers
       */
    create(owners: [Signer, ...Array<Signer>], trustees: [Signer, ...Array<Signer>]): Promise<string>;
    /**
       * Extract either the partial uncrumbs or the fully-decrypted value for the passed signer
       *
       * @param user      The signer credentials
       * @param isOwner   Pass `true` if the user is a data owner, `false` otherwise
       */
    extract(user: Signer, isOwner: boolean): Promise<string>;
}
//# sourceMappingURL=Worker.d.ts.map