"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decrypt = exports.encrypt = void 0;
const ecies = __importStar(require("ecies-geth"));
/**
 * Eventually returns the ECIES-encrypted buffer of the passed message
 *
 * @param msg the message to encrypt
 * @param publicKey the ecies public key
 */
const encrypt = (msg, publicKey) => {
    return ecies.encrypt(publicKey, msg);
};
exports.encrypt = encrypt;
/**
 * Eventually returns the ECIES-decrypted buffer of the passed ciphertext
 *
 * @param ciphered the ciphertext to decrypt
 * @param privateKey the ecies private key
 */
const decrypt = (ciphered, privateKey) => {
    return ecies.decrypt(privateKey, ciphered);
};
exports.decrypt = decrypt;
