export declare const DEFAULT_CRYPTO_HASH_ENGINE = "sha-256";
export declare const DEFAULT_HASH_LENGTH = 64;
export declare const ECIES_ALGORITHM = "ecies";
export declare const RSA_ALGORITHM = "rsa";
/**
 * Test whether the passed algorithm is compliant with the current system
 *
 * @param name the algorithm code name to test
 */
export declare const existsAlgorithm: (name: string) => boolean;
/**
 * Hash the passed string using SHA-256 hash algorithm (as of the latest version of the Crumbl&trade;)
 *
 * @param string the data to hash
 * @param hashEngine the name of the hash engine (default: `sha-256`)
 * @returns the hexadecimal representation of the hashed data
 */
export declare const hash: (data: string, hashEngine?: string) => Promise<string>;
//# sourceMappingURL=index.d.ts.map