"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isBase64String = exports.toBase64 = exports.Base64 = void 0;
class Base64 {
    constructor(encoded) {
        this.encoded = encoded;
    }
    decoded() {
        return this.toBytes();
    }
    length() {
        return this.encoded.length;
    }
    toBytes() {
        if (this.encoded === '') {
            return new Buffer(0);
        }
        return Buffer.from(this.encoded, 'base64');
    }
    toString() {
        return this.encoded;
    }
}
exports.Base64 = Base64;
const toBase64 = (buf) => {
    if (buf.length === 0) {
        return new Base64('');
    }
    return new Base64(buf.toString('base64'));
};
exports.toBase64 = toBase64;
const base64Regex = new RegExp(/[A-Za-z0-9+/=]/);
const isBase64String = (s) => {
    return base64Regex.test(s);
};
exports.isBase64String = isBase64String;
